=== debian/rules ===
#!/usr/bin/make -f

export LANG=C.UTF-8
export REBAR=/usr/bin/rebar
export PREFIX=/usr

%:
	dh $@

override_dh_auto_test: .home
	HOME=$(CURDIR)/.home dh_auto_test

override_dh_auto_clean:
	$(RM) -r .home
	dh_auto_clean

.home:
	mkdir $@
