=== debian/tests/control ===
Tests: run-all
