=== debian/watch ===
version=3
https://github.com/elixir-lang/elixir/releases/ .*/elixir/archive/v(.*).tar.gz
