## elixir-lang 1.2.6

=== debian/changelog ===
elixir-lang (1.2.6-1) unstable; urgency=medium

  * Evgeny is now the maintainer

  [ Antonio Terceiro ]
  * New upstream release
  * Acknowledge Non-maintainer upload; thanks to Anton Gladky and Sergei
    Golovan.
  * debian/rules:
    - also set LC_ALL=C.UTF-8 since the VM requires UTF-8 for correct
      operation.
    - kill epmd after running tests here instead of with a patch to the
      Makefile (Closes: #819122)
  * debian/control:
    - Bump Standards-Version to 3.9.8, no other changes needed
    - Use https:// URL's for Vcs-*

  [ Evgeny Golyshev ]
  * Add patch disabling tests related to rebar3

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 16 Jun 2016 09:48:49 -0300

elixir-lang (1.1.0-1.1) unstable; urgency=medium

  [ Anton Gladky ]
  * Non-maintainer upload.

  [ Sergei Golovan ]
  * Kill daemon after test phase. (Closes: #819122)

 -- Anton Gladky <gladk@debian.org>  Fri, 13 May 2016 21:02:10 +0200

elixir-lang (1.1.0-1) unstable; urgency=medium

  [ Evgeny Golyshev ]
  * Replace dependency on `erlang` with `erlang-base`. This avoids pulling
    several X11-related packages when installing on a headless system.
  * Improved package description

  [ Antonio Terceiro ]
  * New upstream release. This package will now be based on released upstream
    tarballs.
  * debian/watch: restrict to final releases
  * debian/copyright:
    - add `rebar` to Files-Excluded.
  * debian/control:
    - Switch Architecture: from `any` to `all`. Elixir code gets compiled to
      bytecode for the Erlang VM, so it is not architecture dependent.
    - Build-Depends:
      + remove `erlang` (but keep `erlang-dev)
      + add erlang-parsetools, erlang-eunit

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 28 Sep 2015 11:14:32 -0300
