=== debian/control ===
Source: elixir-lang
Section: interpreters
Priority: optional
Maintainer: Evgeny Golyshev <eugulixes@gmail.com>
Uploaders: Antonio Terceiro <terceiro@debian.org>
Build-Depends: debhelper (>= 9~),
               erlang-dev (>= 1:18),
               erlang-dialyzer (>= 1:18),
               erlang-eunit (>= 1:18),
               erlang-parsetools (>= 1:18),
               git,
               rebar
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-elixir/elixir.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-elixir/elixir.git
Homepage: http://elixir-lang.org/
Testsuite: autopkgtest

Package: elixir
Architecture: all
Depends: erlang-base (>= 1:18) | erlang-base-hipe (>= 1:18),
         ${misc:Depends}
Description: functional meta-programming aware language
 Elixir is a functional meta-programming aware language intended primarily for
 developing distributed, fault-tolerant and scalable systems. Elixir source
 code is compiled to bytecode for the Erlang Virtual Machine (EVM), and can use
 Erlang libraries transparently.
