=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Evgeny Golyshev <eugulixes@gmail.com>
 Uploaders: Antonio Terceiro <terceiro@debian.org>
 Build-Depends: debhelper (>= 9~),
+               erlang-crypto (>= 1:18),
                erlang-dev (>= 1:18),
                erlang-dialyzer (>= 1:18),
                erlang-eunit (>= 1:18),
