=== debian/watch ===
version=3
https://github.com/elixir-lang/elixir/releases/ .*/elixir/archive/v([0-9.]*).tar.gz
