## elixir-lang 1.3.3+really1.10.3

=== debian/changelog ===
elixir-lang (1.3.3+really1.10.3-0+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload.
  * New upstream version. Required to build latest rabbitmq-server in Stretch.

 -- Markus Koschany <apo@debian.org>  Thu, 01 Dec 2022 22:08:40 +0100

elixir-lang (1.10.3.dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove dependency of the elixir binary package on erlang-pcre-<version>,
    because it isn't necessary anymore (closes: #963043).

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 18 Jun 2020 18:22:53 +0300

elixir-lang (1.10.3.dfsg-1) unstable; urgency=medium

  * New upstream release (closes: #959701, #959160, #959988).
  * Remove patches/remove-test-executes-rpc-instructions.patch.
  * Require Erlang 21.0 or later.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Wed, 06 May 2020 20:33:40 +0300

elixir-lang (1.9.1.dfsg-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Add remove-test-executes-rpc-instructions.patch, as this test reliably
    fails on arm64 and mips64el.

 -- Thomas Goirand <zigo@debian.org>  Mon, 04 Nov 2019 11:27:07 +0100

elixir-lang (1.9.1.dfsg-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Re-attempt unit testing (up to 3 times) if failed (Closes: #942688).

 -- Thomas Goirand <zigo@debian.org>  Wed, 30 Oct 2019 12:23:33 +0100

elixir-lang (1.9.1.dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add a dependency of the elixir binary package on erlang-pcre-<version>
    virtual package to prevent installation when PCRE in Erlang changes,
    invalidating precompiled regexes (closes: #941124).
  * Move to ${erlang:Depends} substitution variable to calculate the
    dependencies automatically.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 13 Oct 2019 09:39:24 +0300

elixir-lang (1.9.1.dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Elixir is endianness-dependent, so substitute 'Architecture: all' for
    'Architecture: any' in debian/control.
  * Increase version number of Erlang in debian/control.
  * Remove disable_tests_to_prevent_failing_with_erlang_22.patch.
  * Adapt remove_rebar3_related_tests.patch to the current Elixir release.
  * Improve debian/tests/run-all
    - do cleanup more carefully after running tests;
    - do cleanup on the following signals: SIGHUP, SIGINT, SIGQUIT and SIGABRT;
    - use bash instead of dash.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Fri, 19 Jul 2019 13:29:07 +0300

elixir-lang (1.7.4.dfsg-2) unstable; urgency=medium

  * Fix debian/tests/run-all to make it run tests properly.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Thu, 18 Jul 2019 12:36:34 +0300

elixir-lang (1.7.4.dfsg-1) unstable; urgency=medium

  * Apply patch provided by Tomas Janousek (Closes: #930497)
    - The patch makes Elixir explicitly depend on
      erlang-base:any | erlang-base-hipe:any
  * Exclude lib/mix/test/fixtures/rebar and lib/mix/test/fixtures/rebar3.
  * Specify license for lib/elixir/unicode/*.txt in debian/copyright.
  * Add remove_rebar3_related_tests.patch not to run the rebar3 related
    tests because we don't have rebar3.
  * Add use_rebar_instead_of_rebar3_in_tests.patch to fix the bug which
    made the Mix tests use only rebar3.
  * Add .dfsg suffix to the package version number to make it clear that
    the upstream archive must be repacked with the purpose of removing
    such binaries as rebar and rebar3.
  * Add disable_tests_to_prevent_failing_with_erlang_22.patch to disable the
    tests which fail under Erlang/OTP 22.

 -- Evgeny Golyshev <eugulixes@gmail.com>  Sun, 14 Jul 2019 23:38:27 +0300

elixir-lang (1.7.4-0.1) unstable; urgency=medium

  * Non-maintainer upload with authorization from current maintainer.
  * New upstream release:
    - Fixes FTBFS (Closes: #910307).
  * Removed all patches.
  * Add patch to remove the UTF-8 warning (Closes: #912207).

 -- Thomas Goirand <zigo@debian.org>  Tue, 30 Oct 2018 07:56:01 +0000

elixir-lang (1.6.5-1) unstable; urgency=medium

  [ Antonio Terceiro ]
  * Drop myself from the Uploaders field

  [ Evgeny Golyshev ]
  * New upstream release (Closes: #869030)
    - The tests from the latest version with newer dependencies seem to be
      fine again (Closes: #871120)
  * Substitute alioth for salsa in Vcs-Browser and Vcs-Git fields
  * Add debian/upstream/metadata
  * Remove Testsuite from debian/control
  * Bump Standards-Version to 4.1.4
  * Bump compat version to 10
  * Add docs file containing NOTICE
  * Use only https in Format field of debian/copyright
  * Do not mention lib/elixir/src/elixir_parser.erl in debian/copyright
  * Disable one more rebar3 related test
  * Temporarily disable rebar related test

 -- Evgeny Golyshev <eugulixes@gmail.com>  Wed, 09 May 2018 23:22:08 +0300
