=== debian/changelog ===
elixir-lang (1.7.4-0.1+deb10u1) buster-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * Tighten build-dependency on erlang 1:22.2.7+dfsg-1+deb10u1.

 -- Markus Koschany <apo@debian.org>  Sat, 08 Jul 2023 18:50:16 +0200
